%% Perfectly Matched Layer BC in BPM based on Method of Lines 

clear all; close all;

%% load input parameters
Parameters

%% Definition of grid, AA, BB arrays
Grid

%% Initial condition = Gaussian propagating at angle
E0 = GaussianBeam1D(cx,0.0,w0,k0,0.0,-kx);

%% this will hold the map of amplitude in z-x space
map = zeros(100,NX);
map(1,:) = E0;

%% PROPAGATE
tic;
for k=2:200
   [zs Es] = Propagate(E0,NX,dx,k0,zmax/200,AA,BB);
   E0 = Es(end,:);
   map(k,:) = E0;
end
toc;

figure(1);
pcolor(log10(abs(map).^2 + 1.0e-20)); shading flat; colorbar;

%% Initial condition = Gaussian propagating at angle
E0 = GaussianBeam1D(cx,0.0,w0,k0,0.0,+kx);

%% this will hold the map of amplitude in z-x space
map = zeros(100,NX);
map(1,:) = E0;

%% PROPAGATE
tic;
for k=2:200
   [zs Es] = Propagate(E0,NX,dx,k0,zmax/200,AA,BB);
   E0 = Es(end,:);
   map(k,:) = E0;
end
toc;

figure(2);
pcolor(log10(abs(map).^2 + 1.0e-20)); shading flat; colorbar;


