%% Input beam parameters
  lambda  = 633e-9; % wavelength 
  w0 = 1.0e-04;     % beam radius (waist)
  f  =+0.0e+00;     % beam focus
  angle = +1.0;      % angle in deg
  
%% Computational grid etc.    
  LX = 0.25e-02;             % x-box size (transverse dimension)
  NX = 500;                 % number of points in x-dimension
  
%% Integration control
  zmax   =  0.30;              % propagation distance 

%% Derived parameters
  k0 = 2*pi/lambda;      % wavenumber in vacuum 
  kx = k0*angle/360.0*2*pi;


%% ABC
  ww = 1.0/( LX/4.0 );
  
