function [zsp enews] =  Propagate(Ain,nx,dx,k0,zfin,AA,BB)

% 1D
% Uses Method of Lines 
% PML - encoded in AA,BB


 idelta = 1i/(2*k0*dx^2);
 dxcoef = 1/2/dx;
 
 [zsp enews] = ode23(@rhs2,[0 zfin],Ain);

  function df = rhs2(z,y)
    df = zeros(nx,1);
    for x=2:nx-1
      df(x) = idelta*(y(x-1) -2*y(x) + y(x+1))*AA(x) + BB(x)*( y(x+1) - y(x-1) )*dxcoef;
    end
    df(1 ) = 0.0;
    df(nx) = 0.0;
  end

end
