function [zsp enews] =  PropagateI(Ain,nx,dx,k0,zstart,dz,zfin,AA,BB)

% 2D BPM propagator
% Uses Method of Lines
% PEC boundary

% n2 = 1.0e-23;
% IU = 3.0e+16;

ideltax = 1i/(2*k0*dx^2);
ideltay = ideltax;
%inonl   = 1i*k0*n2*IU;

options = odeset('AbsTol', 1.0e-03, 'RelTol',0.0e-03);
[zsp enews] = ode23(@rhs2,zstart:dz:zfin,Ain);

    function da = rhs2(z,am)
        da = zeros(nx*nx,1);
        
        for x=1:nx-2
         for y = 1:nx-2
          % dxx part of laplacian
          da(1+ x+y*nx,1)  =               ideltax*(am(1+(x-1)+(y+0)*nx,1) -2.0*am(1+(x+0)+(y+0)*nx,1) +am(1+(x+1)+(y+0)*nx,1))*AA(1+x) + ...
                                           BB(1+x)*(am(1+(x+1)+(y+0)*nx,1) - am(1+(x-1)+(y+0)*nx,1))/(2.0*dx);
          % dyy part of laplacian
          da(1+ x+y*nx,1) = da(1+x+y*nx,1)+ideltay*(am(1+(x+0)+(y-1)*nx,1) -2.0*am(1+(x+0)+(y-0)*nx,1) +am(1+(x+0)+(y+1)*nx,1))*AA(1+y) + ...
                                           BB(1+y)*(am(1+(x+0)+(y+1)*nx,1) - am(1+(x+0)+(y-1)*nx,1))/(2.0*dx);
          % nonlinear part
          % da(1+ x+y*nx,1) = da(1+x+y*nx,1) + inonl*abs(am(1+x+y*nx,1))^2*am(1+x+y*nx,1);
            end
        end
    end
end

